#!perl

use IO::File;

sub fix_gsoap_common_stub_h {

	my $STATUS_NORMAL      		 = 0;
	my $STATUS_BEGIN_SOAP_HEADER = 1;
	my $STATUS_BEGIN_SOAP_FAULT	 = 2;
	my $STATUS_DONE  			 = 3;
	
	my $nmsp	 		   = shift;
	my $fname 			   = shift;
	
	my $fname_tmp = $fname . ".tmp";
	my $fhi = new IO::File $fname , O_RDONLY;
	my $fho = new IO::File $fname_tmp, O_WRONLY | O_CREAT | O_TRUNC;
	if ((!defined $fhi) || (!defined $fho)) {
		die "Cannot Open File : $!";
    }
    my $status   = $STATUS_NORMAL;
    my $need_fix = 0;
    my $pattern  = "";
	while (<$fhi>){
		my $content = $_;
		if($status == $STATUS_NORMAL) {
			# Check if the line correspond to /* $fault_detail_class: */
			$pattern = "^/(\\*)(\\s)*SOAP Header:(\\s)*(\\*)/";
			if( $content =~ m/$pattern/){
				#print "SOAP HEADER Found : $content\n";
				$status = $STATUS_BEGIN_SOAP_HEADER;
				$content = "#ifndef __GLITE_GSOAP_COMMON_DEFINITION  \/\/ autogen \n" .
				"#define __GLITE_GSOAP_COMMON_DEFINITION \/\/ autogen \n" .
				"SOAP_END_NAMESPACE($nmsp) \/\/ autogen \n" . $content;
			}
		} elsif($status == $STATUS_BEGIN_SOAP_HEADER) {
			# Check Line  /* SOAP Fault: */
			$pattern = "^/(\\*)(\\s)*SOAP Fault:(\\s)*(\\*)/";
			if( $content =~ m/$pattern/){
				#print "SOAP Fault Found : $content\n";
				$status = $STATUS_BEGIN_SOAP_FAULT;
			}
		} elsif($status == $STATUS_BEGIN_SOAP_FAULT) {
			# Check Line  };
			$pattern = "^};";
			if( $content =~ m/$pattern/){
				#print "SOAP Fault Closed : $content\n";
				$status = $STATUS_DONE;
				$content = $content . "SOAP_BEGIN_NAMESPACE($nmsp) \/\/ autogen \n" . 
				"#endif \/\/__GLITE_GSOAP_COMMON_DEFINITION \/\/ autogen\n";
				print "File $fname Patched\n";
			}
		}
		$fho->print($content);
	}
	
	$fhi->close();
	$fho->close();
	
	rename($fname_tmp, $fname) || die "Cannot rename file: $!";
}

sub fix_gsoap_common_c_cpp {

	my $STATUS_NORMAL      		= 0;
	my $STATUS_BEGIN_NAMESPACE  = 1;
	my $STATUS_DONE  			= 2;
	
	my $nmsp	 		   = shift;
	my $fname 			   = shift;
	
	my $fname_tmp = $fname . ".tmp";
	my $fhi = new IO::File $fname , O_RDONLY;
	my $fho = new IO::File $fname_tmp, O_WRONLY | O_CREAT | O_TRUNC;
	if ((!defined $fhi) || (!defined $fho)) {
		die "Cannot Open File : $!";
    }
    my $status   = $STATUS_NORMAL;
    my $need_fix = 0;
    my $pattern  = "";
	while (<$fhi>){
		my $content = $_;
		if($status == $STATUS_NORMAL) {
			# Check if the line correspond to SOAP_BEGIN_NAMESPACE($nmsp)
			$pattern = "^SOAP_BEGIN_NAMESPACE\\($nmsp\\)";
			if( $content =~ m/$pattern/){
				#print "SOAP_BEGIN_NAMESPACE Found : $content\n";
				$status = $STATUS_BEGIN_NAMESPACE;
				$content = "\/\/" . $content . 
				"using namespace $nmsp; \/\/ autogen \n";
			}
		} elsif($status == $STATUS_BEGIN_NAMESPACE) {
			# Check #endif
			$pattern = "^#endif";
			if( $content =~ m/$pattern/){
				#print "Endif Found : $content\n";
				$status = $STATUS_DONE;
				$content =$content . "SOAP_BEGIN_NAMESPACE($nmsp) \/\/ autogen\n";
				print "File $fname Patched\n";
			}
		}
		$fho->print($content);
	}
	
	$fhi->close();
	$fho->close();
	
	rename($fname_tmp, $fname) || die "Cannot rename file: $!";
}


my $arg_nmsp 	= shift;
my $arg_stub_h 	= shift;
my $arg_c_cpp	= shift;

fix_gsoap_common_stub_h($arg_nmsp,$arg_stub_h);
fix_gsoap_common_c_cpp($arg_nmsp,$arg_c_cpp);
