#!perl

use IO::File;


sub generate_env_file {

	my $fname = shift;
	
	my $fho = new IO::File $fname, O_WRONLY | O_CREAT | O_TRUNC;
	if (!defined $fho) {
		die "Cannot Open File : $!";
    }
	$fho->print("#include \"stdsoap2.h\"   					    \/\/ autogen\n".
	            "struct Namespace namespaces[] ={{NULL, NULL}}; \/\/ autogen\n");
	
	$fho->close();
}

sub generate_soapdefs_file {

	my $fname = shift;
	
	my $fho = new IO::File $fname, O_WRONLY | O_CREAT | O_TRUNC;
	if (!defined $fho) {
		die "Cannot Open File : $!";
    }
	$fho->print(   	"#ifndef SOAPDEFS_H_   		\/\/ autogen\n" .
					"#define SOAPDEFS_H_   		\/\/ autogen\n" .
					"#ifdef WITH_NONAMESPACES   \/\/ autogen\n" .
					"#undef WITH_NONAMESPACES   \/\/ autogen\n" .
					"#endif   					\/\/ autogen\n" .
					"#ifdef WITH_NOGLOBAL   	\/\/ autogen\n" .
					"#undef WITH_NOGLOBAL   	\/\/ autogen\n" .
					"#endif   					\/\/ autogen\n" .
					"#ifdef SOAP_FMAC3   		\/\/ autogen\n" .
					"#undef SOAP_FMAC3   		\/\/ autogen\n" .
					"#define SOAP_FMAC3   		\/\/ autogen\n" .
					"#endif   					\/\/ autogen\n" .
					"#ifdef SOAP_FMAC4   		\/\/ autogen\n" .
					"#undef SOAP_FMAC4   		\/\/ autogen\n" .
					"#define SOAP_FMAC4   		\/\/ autogen\n" .
					"#endif   					\/\/ autogen\n" .
					"#endif \/\/SOAPDEFS_H_   	\/\/ autogen\n"
	);
	
	$fho->close();
}


my $arg_nsmp_file = shift;
my $arg_soapdef_file = shift;
generate_env_file($arg_nsmp_file);
generate_soapdefs_file($arg_soapdef_file)
